﻿#Область ОбработчикиСобытий

Процедура ПриКомпоновкеРезультата(ДокументРезультат, ДанныеРасшифровки, СтандартнаяОбработка)
	
	СтандартнаяОбработка = Ложь;
	
	НастройкиИсточника = НастройкиПодключения();
	Параметры = ПараметрыПолучаемыхДанных();
	
	СтруктураТаблицПодключеннойБазы = кс_ОбработкаДанныхДляОтчетаСравненияБазДанных.ПолучитьДанныеБазыИсточника(НастройкиИсточника, Параметры);
	
	Если СтруктураТаблицПодключеннойБазы = Неопределено Тогда
		
		Возврат;
		
	КонецЕсли;
	
	СтруктураТаблицТекущейБазы = кс_ОбработкаДанныхДляОтчетаСравненияБазДанных.СтруктураТаблиц(Параметры, Истина);
	
	ВнешниеНаборы = Новый Структура;
	
	МассивОписанийТаблицКСравнению = МассивИменТаблицСВыбраннымиПолямиКСравнению();
	
	СписокВыводимыхТаблиц = Параметры.СписокТаблиц;
	ИспользованиеСпискаТаблиц = Параметры.ИспользованиеСпискаТаблиц;
	
	
	Для Каждого ТаблицаОписание Из МассивОписанийТаблицКСравнению Цикл
		
		Наименование = ТаблицаОписание.Наименование;
		ПоляКСравнению = ТаблицаОписание.ПоляКСравнению;
		ПоляРасшифровки = ТаблицаОписание.ПоляРасшифровки;
		
		Если ИспользованиеСпискаТаблиц = Истина 
			И СписокВыводимыхТаблиц.НайтиПозначению(Наименование) = Неопределено Тогда
			
			Продолжить;
			
		КонецЕсли;
		
		Таблица = ОбработкаТаблиц(СтруктураТаблицТекущейБазы[Наименование], СтруктураТаблицПодключеннойБазы[Наименование], ПоляКСравнению, ПоляРасшифровки);
		
		ВнешниеНаборы.Вставить("Данные"+Наименование, Таблица);
		
		ВыводТаблицыВОтчет(Наименование, ВнешниеНаборы, ДокументРезультат, ДанныеРасшифровки);
		
	КонецЦикла;
	
КонецПроцедуры

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

Процедура ВыводТаблицыВОтчет(ИмяТаблицы, ВнешниеНаборы, ДокументРезультат, ДанныеРасшифровки)
	
	МакетКоличественныеПараметры = ПолучитьМакет("КоличественныеПараметры");
	
	Таблица = ВнешниеНаборы["Данные"+ИмяТаблицы];
	
	СовпадающиеСтроки = Таблица.НайтиСтроки(Новый Структура("Источник", 0));
	
	КоличествоСовпадает = СовпадающиеСтроки.Количество();
	КоличествоУПП = Таблица.НайтиСтроки(Новый Структура("Источник"
		, кс_ОбработкаДанныхДляОтчетаСравненияБазДанных.ИсточникБазыИсточника())).Количество();
	КоличествоERP = Таблица.НайтиСтроки(Новый Структура("Источник"
		, кс_ОбработкаДанныхДляОтчетаСравненияБазДанных.ИсточникТекущейБазы())).Количество();
	
	Для Каждого Строка Из СовпадающиеСтроки Цикл
		Таблица.Удалить(Строка);
	КонецЦикла;
	
	
	Область = МакетКоличественныеПараметры.ПолучитьОбласть("ОбластьЗаголовок");
	
	СинонимТаблицы = ПолучитьНаименованиеТаблицы(ИмяТаблицы);
	
	ОБласть.Параметры.Заголовок = СинонимТаблицы;
	ОБласть.Параметры.Совпадают = КоличествоСовпадает;
	ОБласть.Параметры.УПП = КоличествоУПП;
	ОБласть.Параметры.ERP = КоличествоERP;
	
	ДокументРезультат.Вывести(Область);
	
	Если КоличествоУПП = 0 И КоличествоERP = 0 Тогда 
		
		ОбластьСовпадение = МакетКоличественныеПараметры.ПолучитьОбласть("ОбластьСовпадение");
		
		ДокументРезультат.Вывести(ОбластьСовпадение);
		
		Возврат;
		
	КонецЕсли;
	
	Макет = Отчеты.кс_СравнениеДанных.ПолучитьМакет(ИмяТаблицы);
	
	НастройкиОформленияОтчета(Макет, ДокументРезультат);
	
	КомпоновщикМакета = Новый КомпоновщикМакетаКомпоновкиДанных;
	МакетКомпоновки = КомпоновщикМакета.Выполнить(
		Макет,
		Макет.НастройкиПоУмолчанию, ДанныеРасшифровки);
	
	ПроцессорКомпоновки = Новый ПроцессорКомпоновкиДанных;
	ПроцессорКомпоновки.Инициализировать(МакетКомпоновки, ВнешниеНаборы, ДанныеРасшифровки,Истина);
	
	ПроцессорВывода = Новый ПроцессорВыводаРезультатаКомпоновкиДанныхВТабличныйДокумент;
	ПроцессорВывода.УстановитьДокумент(ДокументРезультат);
	ПроцессорВывода.Вывести(ПроцессорКомпоновки);
	
КонецПроцедуры

Функция МассивИменТаблицСВыбраннымиПолямиКСравнению();
	
	МассивТаблицКСравнению = Новый Массив;
	
	Ключи = "Наименование, ПоляКСравнению, ПоляРасшифровки";
	
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "Контрагенты"
	, "УникальныйИдентификатор,ИНН,КПП,СтроковоеЮрФизЛицо", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ДоговорыКонтрагентов"
	, "УникальныйИдентификатор,Валюта,КонтрагентИдентификатор", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "Склады"
	, "УникальныйИдентификатор,Наименование", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "Номенклатура"
	, "УникальныйИдентификатор,СтроковоеСтавкиНДС,ЕдиницаХраненияОстатков", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ФизическиеЛица"
	, "УникальныйИдентификатор,Наименование,ИНН", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ГруппаАналитическогоУчета"
	, "УникальныйИдентификатор,Наименование", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ПоступлениеДенежныхДокументов"
	, "УникальныйИдентификатор,Год,КонтрагентУникальныйИдентификатор,ДоговорУникальныйИдентификатор,ДенежныйДокументКСравнению", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ПеремещениеТоваров"
	, "УникальныйИдентификатор,УникальныйИдентификаторТовары,Год,УникальныйИдентификаторСкладОтправитель,УникальныйИдентификаторСкладПолучатель", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "СписаниеТоваров"
	, "УникальныйИдентификатор,УникальныйИдентификаторНоменклатур,УникальныйИдентификаторСклад,Год", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ОприходованиеМатериаловИзПроизводства"
	, "УникальныйИдентификатор,Год,УникальныйИдентификаторСклад,УникальныйИдентификаторНоменклатур", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ДенежныеДокументы"
	, "УникальныйИдентификатор,Стоимость,Наименование", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "КорректировкаРеализации"
	, "УникальныйИдентификатор,Год,УникальныйИдентификаторНоменклатур,УникальныйИдентификаторПодразделение", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "АвансовыйОтчет"
	, "УникальныйИдентификатор,Год,Сумма,УникальныйИдентификаторПодразделение,УникальныйИдентификаторПрочиеРасходы,УникальныйИдентификаторОплатаПоставщикам", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ПоступлениеДенежныхСредств"
	, "УникальныйИдентификатор,Год,Сумма,УникальныйИдентификаторКонтрагент,УникальныйИдентификаторПодразделение,НомерВходящегоДокумента,ДатаВходящегоДокумента", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "СписаниеДенежныхСредств"
	, "УникальныйИдентификатор,Год,Сумма", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "РесурсныеСпецификации"
	, "УникальныйИдентификатор", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "СтатьиДвиженияДенежныхСредств"
	, "УникальныйИдентификатор,Наименование", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "Подразделения"
	, "УникальныйИдентификатор,Наименование", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ПодразделенияОрганизаций"
	, "УникальныйИдентификатор,Наименование", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "СтатьиРасходов"
	, "УникальныйИдентификатор","Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ПрочиеДоходыИРасходы"
	, "УникальныйИдентификатор", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "БанковскиеСчетаКонтрагентов"
	, "УникальныйИдентификатор,БИК,НомерСчета,Валюта", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ПередачаМатериаловВЭксплуатацию"
	, "УникальныйИдентификатор,УникальныйИдентификаторНоменклатур,Год,УникальныйИдентификаторСклад,УникальныйИдентификаторПодразделение", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ОприходованиеТоваров"
	, "УникальныйИдентификатор,УникальныйИдентификаторНоменклатур,Год,УникальныйИдентификаторПодразделение,УникальныйИдентификаторСтатьяДоходов,УникальныйИдентификаторСклад", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "РеализацияТоваровУслуг"
	, "УникальныйИдентификатор,УникальныйИдентификаторНоменклатур,Дата,Номер,СуммаДокумента,УникальныйИдентификаторСклад,УникальныйИдентификаторДоговор,УникальныйИдентификаторКонтрагент", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "СчетФактураВыданный"
	, "УникальныйИдентификатор,Дата,Номер,УникальныйИдентификаторКонтрагент", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ВыдачаДенежныхДокументовПодотчетнику"
	, "УникальныйИдентификатор,Год,Номер,УникальныйИдентификаторКонтрагент,УникальныйИдентификаторНоменклатур", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ВозвратДенежныхДокументовПоставщику"
	, "УникальныйИдентификатор,Год,Номер,УникальныйИдентификаторКонтрагент,УникальныйИдентификаторНоменклатур,УникальныйИдентификаторСтатьяРасходов", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ВозвратМатериаловИзЭксплуатации"
	, "УникальныйИдентификатор,ДатаДокумента,УникальныйИдентификаторНоменклатур,УникальныйИдентификаторСклад,УникальныйИдентификаторПодразделение", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ВнутреннееПотреблениеТоваров"
	, "УникальныйИдентификатор,Год,УникальныйИдентификаторНоменклатур,УникальныйИдентификаторСклад,УникальныйИдентификаторПодразделение", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ДвижениеПродукцииИМатериалов"
	, "УникальныйИдентификатор,Год,УникальныйИдентификаторНоменклатур", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ОтчетПроизводстваЗаСмену"
	, "УникальныйИдентификатор,Год", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ПоступлениеТоваровУслуг"
	, "УникальныйИдентификатор,Год,УникальныйИдентификаторНоменклатур", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ПриобретениеУслугПрочихАктивов"
	, "УникальныйИдентификатор,Год", "Ссылка"));
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи
	, "ПринятиеКУчетуОС"
	, "УникальныйИдентификатор,Год,УникальныйИдентификаторНоменклатур,УникальныйИдентификаторСклад,УникальныйИдентификаторПодразделение", "Ссылка"));
	
	
	МассивТаблицКСравнению.Добавить(Новый Структура(Ключи, "ПриобретениеТоваровУслуг", "
	|ПоставщикGUID,
	|АвансовыйОтчетGUID,
	|НомерВходящегоДокумента,
	|НаименованиеВходящегоДокумента,
	|ДатаВходящегоДокумента,
	|СоставДляСравнения,
	|", "
	|Поставщик,
	|АвансовыйОтчет
	|"
	));
	
	Возврат МассивТаблицКСравнению;
	
КонецФункции

Процедура НастройкиОформленияОтчета(Макет, ДокументРезультат)
	
	ОтключитьВыводЗаголовка(Макет);
	ОграничитьШиринуКолонок(Макет, 25, 30);
	ОтключитьФиксациюСтрок(Макет);
	
	ДокументРезультат.ВысотаСтраницы = 0;
	
КонецПроцедуры

Функция ПолучитьНаименованиеТаблицы(ИмяТаблицы)
	
	СинонимТаблицы = СинонимЗначенияПеречисленияПоИмени("кс_ТаблицыДляПостроенияОтчетаСравненияБаз", ИмяТаблицы);
	
	Возврат СинонимТаблицы;
	
КонецФункции

Функция СинонимЗначенияПеречисленияПоИмени(пИмяПеречисления, пИмяЗначения)
	КолекцияЗначенийПеречисления = Метаданные.Перечисления[пИмяПеречисления].ЗначенияПеречисления;
    Для каждого пНайденноеЗначение из КолекцияЗначенийПеречисления Цикл
        Если пНайденноеЗначение.Имя = пИмяЗначения Тогда
            Возврат пНайденноеЗначение.Синоним;
        КонецЕсли
    КонецЦикла;
    Возврат неопределено;
КонецФункции

Процедура ОтключитьВыводЗаголовка(Макет)
	
	СтруктураКомпоновки = Макет.ВариантыНастроек.Основной.Настройки.Структура;
	
	Для Каждого Элемент Из СтруктураКомпоновки Цикл
		
		ПараметрЗаголовок = Элемент.ПараметрыВывода.НайтиЗначениеПараметра(Новый ПараметрКомпоновкиДанных("Заголовок"));
		
		Если ПараметрЗаголовок <> Неопределено Тогда
			ПараметрЗаголовок.Использование = Ложь;
		КонецЕсли;
		
	КонецЦикла;
	
КонецПроцедуры

Процедура ОграничитьШиринуКолонок(Макет, МинимальнаяШиринаКолонки = 0, МаксимальнаяШиринаКолонки = 0)
	
	Для Каждого Набор Из Макет.НаборыДанных Цикл 
		Для Каждого Поле Из Набор.Поля Цикл
			ПараметрМаксимальнаяШирина = Поле.Оформление.Элементы.Найти("МаксимальнаяШирина");
			ПараметрМаксимальнаяШирина.Использование = Истина;
			ПараметрМаксимальнаяШирина.Значение = МаксимальнаяШиринаКолонки;
			
			ПараметрМинимальнаяШирина = Поле.Оформление.Элементы.Найти("МинимальнаяШирина");
			ПараметрМинимальнаяШирина.Использование = Истина;
			ПараметрМинимальнаяШирина.Значение = МинимальнаяШиринаКолонки;
		КонецЦикла;
	КонецЦикла;
	
КонецПроцедуры

Процедура ОтключитьФиксациюСтрок(Макет)
	
	ПараметрыВывода = Макет.ВариантыНастроек.Основной.Настройки.ПараметрыВывода.Элементы;
	
	ФиксацияСверху = ПараметрыВывода.Найти("ФиксацияСверху");
	ФиксацияСверху.Использование = Истина;
	ФиксацияСверху.Значение = ФиксацияКомпоновкиДанных.НеИспользовать;
	
	ФиксацияСлева = ПараметрыВывода.Найти("ФиксацияСлева");
	ФиксацияСлева.Использование = Истина;
	ФиксацияСлева.Значение = ФиксацияКомпоновкиДанных.НеИспользовать;
	
КонецПроцедуры

Функция НастройкиПодключения()
	
	Для Каждого Элемент Из КомпоновщикНастроек.ПользовательскиеНастройки.Элементы Цикл
		Если Элемент.Параметр = Новый ПараметрКомпоновкиДанных("НастройкиПодключения") Тогда
			Возврат Элемент.Значение;
		КонецЕсли;
	КонецЦикла;
	
	Возврат Неопределено;
	
КонецФункции

Функция ПараметрыПолучаемыхДанных()
	
	Параметры = Новый Структура;
	
	Для Каждого Элемент Из КомпоновщикНастроек.ПользовательскиеНастройки.Элементы Цикл
		Если Элемент.Параметр = Новый ПараметрКомпоновкиДанных("СтандартныйПериод") Тогда
			
			Параметры.Вставить("Период", Элемент.Значение);
			
		ИначеЕсли Элемент.Параметр = Новый ПараметрКомпоновкиДанных("СписокТаблиц") Тогда
			
			СоответствиеИменТаблиц = Новый Соответствие;
			
			Для Каждого ЭлементПеречисления Из Метаданные.Перечисления.кс_ТаблицыДляПостроенияОтчетаСравненияБаз.ЗначенияПеречисления Цикл
				СоответствиеИменТаблиц[Перечисления.кс_ТаблицыДляПостроенияОтчетаСравненияБаз[ЭлементПеречисления.Имя]] = ЭлементПеречисления.Имя;
			КонецЦикла;
			
			СписокТаблицКВыводу = Новый СписокЗначений;
			
			Список = Элемент.Значение;
			Если ТипЗнч(Элемент.Значение) = Тип("СписокЗначений") Тогда
				Для Каждого Строка Из Список Цикл
					СписокТаблицКВыводу.Добавить(СоответствиеИменТаблиц[Строка.Значение]);
				КонецЦикла;
			Иначе
				СписокТаблицКВыводу.Добавить(СоответствиеИменТаблиц[Список]);
			КонецЕсли;
			
			Параметры.Вставить("СписокТаблиц", СписокТаблицКВыводу);
			Параметры.Вставить("ИспользованиеСпискаТаблиц", Элемент.Использование);
		КонецЕсли;
		
	КонецЦикла;
	
	Если ТипЗнч(Параметры.СписокТаблиц) = Тип("СписокЗначений") Тогда
		Для Каждого Элемент Из Параметры.СписокТаблиц Цикл
			
			СписокДляПоиска = Новый СписокЗначений;
			СписокДляПоиска = Параметры.СписокТаблиц.Скопировать();
			ЭлеменПоиска = СписокДляПоиска.НайтиПоЗначению(Элемент.Значение);
			СписокДляПоиска.Удалить(ЭлеменПоиска);
			НайденныйЭлемент = СписокДляПоиска.НайтиПоЗначению(Элемент.Значение);
			
			Если НайденныйЭлемент <> Неопределено Тогда
				Параметры.СписокТаблиц.Удалить(Элемент);
			КонецЕсли;
			
		КонецЦикла;
	КонецЕсли;
	
	Возврат Параметры;
	
КонецФункции

Функция ОбработкаТаблиц(ТаблицаТекущейБазы, ТаблицаБазыИсточника, ГруппировочныеПоля = "", РасшифровочныеПоля)
	
	МассивТаблиц = Новый Массив;
	МассивТаблиц.Добавить(ТаблицаТекущейБазы);
	МассивТаблиц.Добавить(ТаблицаБазыИсточника);
	
	Для Каждого Таблица Из МассивТаблиц Цикл 
		
		ИзменитьТипКолонки(Таблица, "Наименование", "Строка");
		ИзменитьТипКолонки(Таблица, "ПоставщикНаименование", "Строка");
		ИзменитьТипКолонки(Таблица, "НаименованиеВходящегоДокумента", "Строка");
		ИзменитьТипКолонки(Таблица, "НомерВходящегоДокумента", "Строка");
		ИзменитьТипКолонки(Таблица, "ДатаВходящегоДокумента", "Строка");
		ИзменитьТипКолонки(Таблица, "ПоставщикGUID", "Строка");
		ИзменитьТипКолонки(Таблица, "АвансовыйОтчетGUID", "Строка");
		ИзменитьТипКолонки(Таблица, "СоставДляСравнения", "Строка");
		ИзменитьТипКолонки(Таблица, "Состав", "Строка");
		ИзменитьТипКолонки(Таблица, "УникальныйИдентификаторНоменклатур", "Строка");
		ИзменитьТипКолонки(Таблица, "Сумма", "Число");
		ИзменитьТипКолонки(Таблица, "СуммаДокумента", "Число");
		ИзменитьТипКолонки(Таблица, "Товары", "Строка");
		ИзменитьТипКолонки(Таблица, "ДенежныйДокумент", "Строка");
		ИзменитьТипКолонки(Таблица, "ДенежныйДокументКСравнению", "Строка");
		ИзменитьТипКолонки(Таблица, "УникальныйИдентификаторТовары", "Строка");
		ИзменитьТипКолонки(Таблица, "УникальныйИдентификаторПрочиеРасходы", "Строка");
		ИзменитьТипКолонки(Таблица, "УникальныйИдентификаторОплатаПоставщикам", "Строка");
		ИзменитьТипКолонки(Таблица, "СоставПрочиеРасходы", "Строка");
		ИзменитьТипКолонки(Таблица, "СоставОплатаПоставщикам", "Строка");
		ИзменитьТипКолонки(Таблица, "ДоговорНаименование", "Строка");
		ИзменитьТипКолонки(Таблица, "Представление", "Строка");
		
		
	КонецЦикла;
	
	Запрос = Новый Запрос;
	
	Запрос.Текст =
	#Область ТекстЗапроса
	"ВЫБРАТЬ
	|	&БлокГруппируемыхБезСуфф,
	|	&БлокТекТаблБезСуфф
	|	&БлокРасшифровочныхБезСуфф
	|ПОМЕСТИТЬ
	|	ВТЗ1
	|ИЗ
	|	&ТаблицаТекущейБазы КАК ТЗ
	|;
	|
	|//////////////////////////////
	|
	|ВЫБРАТЬ
	|	&БлокТаблИсточникБезСуфф
	|	&БлокГруппируемыхБезСуфф
	|ПОМЕСТИТЬ
	|	ВТЗ2
	|ИЗ
	|	&ТаблицаБазыИсточника КАК ТЗ
	|;
	|
	|////////////////////////
	|
	|ВЫБРАТЬ
	|	&БлокГруппируемыхБезСуфф,
	|	&ИсточникТекущейБазы КАК Источник,
	|	&БлокТекТаблССуфф
	|	&БлокТаблИсточникNull
	|	&БлокРасшифровочныхБезСуфф
	|ПОМЕСТИТЬ
	|	ТаблицаБезГруппировок
	|ИЗ
	|	ВТЗ1 КАК ТЗ
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	&БлокГруппируемыхБезСуфф,
	|	&ИсточникБазыИсточника КАК Источник,
	|	&БлокТекТаблNull
	|	&БлокТаблИсточникССуфф
	|	&БлокРасшифровочныхNull
	|ИЗ
	|	ВТЗ2 КАК ТЗ
	|;
	|
	|////////////////////////////////
	|
	|ВЫБРАТЬ
	|	&БлокГруппируемыхБезСуфф,
	|	СУММА(ТЗ.Источник) КАК Источник,
	|	&БлокТекТаблМакс
	|	&БлокТаблИсточникМакс
	|	&БлокРасшифровочныхМакс
	|ИЗ
	|	ТаблицаБезГруппировок КАК ТЗ
	|
	|СГРУППИРОВАТЬ ПО
	|	&БлокГруппируемыхССуфф
	|
	|";
	#КонецОбласти
	
	Запрос.УстановитьПараметр("ИсточникТекущейБазы", кс_ОбработкаДанныхДляОтчетаСравненияБазДанных.ИсточникТекущейБазы());
	Запрос.УстановитьПараметр("ИсточникБазыИсточника", кс_ОбработкаДанныхДляОтчетаСравненияБазДанных.ИсточникБазыИсточника());
	
	МассивБлокГруппируемыхБезСуфф = Новый Массив;
	МассивБлокГруппируемыхССуфф = Новый Массив;
	МассивБлокРасшифровочныхБезСуфф = Новый Массив;
	МассивБлокРасшифровочныхNull = Новый Массив;
	МассивБлокРасшифровочныхМакс = Новый Массив;
	МассивГруппировочныхПолей = Новый Массив;
	МассивРасшифровочныхПолей = Новый Массив;
	
	СтруктураГруппировочныхПолей = Новый Структура(ГруппировочныеПоля);
	Для Каждого ЭлементСтруктуры Из СтруктураГруппировочныхПолей Цикл 
		МассивГруппировочныхПолей.Добавить(ЭлементСтруктуры.Ключ);
	КонецЦикла;
	
	СтруктураРасшифровочныхПолей = Новый Структура(РасшифровочныеПоля);
	Для Каждого ЭлементСтруктуры Из СтруктураРасшифровочныхПолей Цикл 
		МассивРасшифровочныхПолей.Добавить(ЭлементСтруктуры.Ключ);
	КонецЦикла;
	
	Для каждого Поле Из МассивГруппировочныхПолей Цикл
		МассивБлокГруппируемыхБезСуфф.Добавить("ТЗ." + Поле + " КАК " + Поле);
		МассивБлокГруппируемыхССуфф.Добавить(Поле);
	КонецЦикла;
	
	Для каждого Поле Из МассивРасшифровочныхПолей Цикл
		МассивБлокРасшифровочныхБезСуфф.Добавить("ТЗ." + Поле + " КАК " + Поле);
		МассивБлокРасшифровочныхNull.Добавить("NULL КАК " + Поле);
		МассивБлокРасшифровочныхМакс.Добавить("МАКСИМУМ(ТЗ." + Поле + ") КАК " + Поле);
	КонецЦикла;
	
	МассивБлокТекТаблБезСуфф = Новый Массив;
	МассивБлокТекТаблССуфф = Новый Массив;
	МассивБлокТекТаблNull = Новый Массив;
	МассивБлокТекТаблМакс = Новый Массив;
	
	Суфф = кс_ОбработкаДанныхДляОтчетаСравненияБазДанных.СуффиксТекущейБазы();
	Для каждого Колонка Из ТаблицаТекущейБазы.Колонки Цикл
		если МассивГруппировочныхПолей.Найти(Колонка.Имя) <> Неопределено тогда
			Продолжить;
		КонецЕсли;
		если МассивРасшифровочныхПолей.Найти(Колонка.Имя) <> Неопределено тогда
			Продолжить;
		КонецЕсли;
		МассивБлокТекТаблБезСуфф.Добавить("ТЗ." + Колонка.Имя + " КАК " + Колонка.Имя + Суфф);
		МассивБлокТекТаблССуфф.Добавить("ТЗ." + Колонка.Имя + Суфф + " КАК " + Колонка.Имя + Суфф);
		МассивБлокТекТаблNull.Добавить("null КАК " + Колонка.Имя + Суфф);
		МассивБлокТекТаблМакс.Добавить("МАКСИМУМ(ТЗ." + Колонка.Имя + Суфф +")");
	КонецЦикла;
	
	МассивБлокТаблИсточникБезСуфф = Новый Массив;
	МассивБлокТаблИсточникССуфф = Новый Массив;
	МассивБлокТаблИсточникNull = Новый Массив;
	МассивБлокТаблИсточникМакс = Новый Массив;
	
	Суфф = кс_ОбработкаДанныхДляОтчетаСравненияБазДанных.СуффиксБазыИсточника();
	Для каждого Колонка Из ТаблицаБазыИсточника.Колонки Цикл
		если МассивГруппировочныхПолей.Найти(Колонка.Имя) <> Неопределено тогда
			Продолжить;
		КонецЕсли;
		если МассивРасшифровочныхПолей.Найти(Колонка.Имя) <> Неопределено тогда
			Продолжить;
		КонецЕсли;
		МассивБлокТаблИсточникБезСуфф.Добавить("ТЗ." + Колонка.Имя + " КАК " + Колонка.Имя + Суфф);
		МассивБлокТаблИсточникССуфф.Добавить("ТЗ." + Колонка.Имя + Суфф + " КАК " + Колонка.Имя + Суфф);
		МассивБлокТаблИсточникNull.Добавить("null КАК " + Колонка.Имя + Суфф);
		МассивБлокТаблИсточникМакс.Добавить("МАКСИМУМ(ТЗ." + Колонка.Имя + Суфф +")");

	КонецЦикла;
	
	
	БлокГруппируемыхБезСуфф = СтрСоединить(МассивБлокГруппируемыхБезСуфф, "," + Символы.ПС + Символы.Таб);
	Запрос.Текст = СтрЗаменить(Запрос.Текст, "&БлокГруппируемыхБезСуфф", БлокГруппируемыхБезСуфф);
	
	БлокГруппируемыхССуфф = СтрСоединить(МассивБлокГруппируемыхССуфф, "," + Символы.ПС + Символы.Таб);
	Запрос.Текст = СтрЗаменить(Запрос.Текст, "&БлокГруппируемыхССуфф", БлокГруппируемыхССуфф);
	
	БлокРасшифровочныхБезСуфф = СтрСоединить(МассивБлокРасшифровочныхБезСуфф, "," + Символы.ПС + Символы.Таб);
	Запрос.Текст = СтрЗаменить(Запрос.Текст, "&БлокРасшифровочныхБезСуфф", БлокРасшифровочныхБезСуфф);
	
	БлокРасшифровочныхNull = СтрСоединить(МассивБлокРасшифровочныхNull, "," + Символы.ПС + Символы.Таб);
	Запрос.Текст = СтрЗаменить(Запрос.Текст, "&БлокРасшифровочныхNull", БлокРасшифровочныхNull);
	
	БлокРасшифровочныхМакс = СтрСоединить(МассивБлокРасшифровочныхМакс, "," + Символы.ПС + Символы.Таб);
	Запрос.Текст = СтрЗаменить(Запрос.Текст, "&БлокРасшифровочныхМакс", БлокРасшифровочныхМакс);
	
	БлокТекТаблБезСуфф = СтрСоединить(МассивБлокТекТаблБезСуфф, "," + Символы.ПС + Символы.Таб);
	ДополнениеБлока(БлокТекТаблБезСуфф);
	Запрос.Текст = СтрЗаменить(Запрос.Текст, "&БлокТекТаблБезСуфф", БлокТекТаблБезСуфф);
	
	БлокТекТаблССуфф = СтрСоединить(МассивБлокТекТаблССуфф, "," + Символы.ПС + Символы.Таб);
	ДополнениеБлока(БлокТекТаблССуфф);
	Запрос.Текст = СтрЗаменить(Запрос.Текст, "&БлокТекТаблССуфф", БлокТекТаблССуфф);	
	
	БлокТекТаблNull = СтрСоединить(МассивБлокТекТаблNull, "," + Символы.ПС + Символы.Таб);
	ДополнениеБлока(БлокТекТаблNull);
	Запрос.Текст = СтрЗаменить(Запрос.Текст, "&БлокТекТаблNull", БлокТекТаблNull);	
	
	БлокТекТаблМакс = СтрСоединить(МассивБлокТекТаблМакс, "," + Символы.ПС + Символы.Таб);
	ДополнениеБлока(БлокТекТаблМакс);
	Запрос.Текст = СтрЗаменить(Запрос.Текст, "&БлокТекТаблМакс", БлокТекТаблМакс);	
	
	БлокТаблИсточникБезСуфф = СтрСоединить(МассивБлокТаблИсточникБезСуфф, "," + Символы.ПС + Символы.Таб);
	ДополнениеБлока(БлокТаблИсточникБезСуфф);
	Запрос.Текст = СтрЗаменить(Запрос.Текст, "&БлокТаблИсточникБезСуфф", БлокТаблИсточникБезСуфф);
	
	БлокТаблИсточникССуфф = СтрСоединить(МассивБлокТаблИсточникССуфф, "," + Символы.ПС + Символы.Таб);
	ДополнениеБлока(БлокТаблИсточникССуфф);
	Запрос.Текст = СтрЗаменить(Запрос.Текст, "&БлокТаблИсточникССуфф", БлокТаблИсточникССуфф);
	
	БлокТаблИсточникNull = СтрСоединить(МассивБлокТаблИсточникNull, "," + Символы.ПС + Символы.Таб);
	ДополнениеБлока(БлокТаблИсточникNull);
	Запрос.Текст = СтрЗаменить(Запрос.Текст, "&БлокТаблИсточникNull", БлокТаблИсточникNull);
	
	БлокТаблИсточникМакс = СтрСоединить(МассивБлокТаблИсточникМакс, "," + Символы.ПС + Символы.Таб);
	ДополнениеБлока(БлокТаблИсточникМакс);
	Запрос.Текст = СтрЗаменить(Запрос.Текст, "&БлокТаблИсточникМакс", БлокТаблИсточникМакс);
	
	
	
	
	Запрос.УстановитьПараметр("ТаблицаТекущейБазы", ТаблицаТекущейБазы);
	Запрос.УстановитьПараметр("ТаблицаБазыИсточника", ТаблицаБазыИсточника);
	
	Результат = Запрос.Выполнить().Выгрузить();
	
	Возврат Результат;
	
КонецФункции

Функция ИзменитьТипКолонки(Таблица, ИмяКолонки, ТипПриведения)
	
	Если Таблица.Колонки.Найти(ИмяКолонки) = Неопределено Тогда
		Возврат Неопределено;
	КонецЕсли;
	
	Если ТипПриведения = "Строка" Тогда
		Тип = Новый ОписаниеТипов("Строка, null",,,,Новый КвалификаторыСтроки(1000, ДопустимаяДлина.Переменная));
	ИначеЕсли ТипПриведения = "Число" Тогда
		Тип = Новый ОписаниеТипов("Число, null",,,,Новый КвалификаторыЧисла(20, 3, ДопустимыйЗнак.Любой));
	КонецЕсли;
	
	Колонка = Таблица.ВыгрузитьКолонку(ИмяКолонки);
	
	Таблица.Колонки.Удалить(ИмяКолонки);
	
	НоваяКолонка = Таблица.Колонки.Добавить(ИмяКолонки, Тип);
	
	Таблица.ЗагрузитьКолонку(Колонка, ИмяКолонки);
	
КонецФункции

Функция ДополнениеБлока(Блок);
	
	Если Блок <> "" Тогда 
		
		Блок = Блок + ",";
		
	КонецЕсли;
	
КонецФункции

#КонецОбласти
